%global reldate 20230812
Summary:        A JSON implementation in C
Name:           json-c
Version:        0.17
Release:        1%{?dist}
License:        MIT
URL:            https://github.com/%{name}/%{name}
Source0:        %{url}/archive/%{name}-%{version}-%{reldate}.tar.gz

BuildRequires:  gcc, cmake, make
%ifarch %{valgrind_arches}
BuildRequires:  valgrind
%endif

%description
JSON-C implements a reference counting object model that allows you to easily
construct JSON objects in C, output them as JSON formatted strings and parse
JSON formatted strings back into the C representation of JSON objects. It aims
to conform to RFC 7159.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains libraries and header files for
developing applications that use %{name}.

%package        doc
Summary:        Reference manual for json-c
BuildArch:     noarch

%description    doc
This package contains the reference manual for %{name}.



%prep
%autosetup -n %{name}-%{name}-%{version}-%{reldate} -p 1



%build
%cmake \
  -DBUILD_STATIC_LIBS:BOOL=OFF       \
  -DCMAKE_BUILD_TYPE:STRING=RELEASE  \
  -DCMAKE_C_FLAGS_RELEASE:STRING=""  \
  -DDISABLE_BSYMBOLIC:BOOL=OFF       \
  -DDISABLE_WERROR:BOOL=ON           \
  -DENABLE_RDRAND:BOOL=ON            \
  -DENABLE_THREADING:BOOL=ON
%cmake_build



%install
%cmake_install

# Documentation
mkdir -p %{buildroot}%{_pkgdocdir}
cp -a ChangeLog README README.* %{buildroot}%{_pkgdocdir}



%check
export USE_VALGRIND=0
%ctest
%ifarch %{valgrind_arches}
export USE_VALGRIND=1
%ctest
%endif
unset USE_VALGRIND



%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig



%files
%license COPYING
%doc AUTHORS
%{_libdir}/lib%{name}.so.*

%files devel
%doc %dir %{_pkgdocdir}
%doc %{_pkgdocdir}/ChangeLog
%doc %{_pkgdocdir}/README*
%{_includedir}/%{name}
%{_libdir}/cmake/%{name}
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}.pc

%files doc
%license %{_datadir}/licenses/%{name}*
%doc %{_pkgdocdir}

%changelog
* Thu Jan 4 2024 wynnfeng <wynnfeng@tencent.com> - 0.17-1
- upgrade to 0.17

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.16-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.16-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.16-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Jul 11 2022 Zhao Zhen <jeremiazhao@tencent.com> - 0.16-1
- Initial building.
